/* This file is part of DATAdesign
 * written by Joachim Van der Auwera
 * (c) 2-5 December 1992 for PROGS, PROfessional & Graphical Software
 *
 * header file with routines to call the DATAdesign engine
 */

#include <stdarg.h>
#include <err.h>

extern long 	DATAdesign; 	/* place with ptr to DATAdesign.engine thing */

/* extension names we need for macros */
#define NEXT	0x4e455854
#define PREV	0x50524556
#define FRST	0x46525354
#define LAST	0x4c415354
#define DUPL	0x4455504c
#define CMRK	0x434d524b
#define DELE	0x44454c45
#define NEWR	0x4e455752
#define IMPL	0x494d504c
#define IUPD	0x49555044
#define IIMP	0x49494d50
#define IRMV	0x49524d56
#define IDEL	0x4944454c
#define UNUS	0x554e5553
#define SAVR	0x53415652
#define SAVF	0x53415646
#define GARB	0x47415242
#define DEFF	0x44454646
#define DEFI	0x44454649
#define DEFB	0x44454642
#define SMRK	0x534d524b
#define GREC	0x47524543
#define SIRS	0x53495253
#define FLDD	0x464c4444
#define IDRE	0x49445245
#define CNTA	0x434e5441
#define CNTR	0x434e5452
#define IDIN	0x4944494e
#define DATE	0x44415445
#define LENR	0x4c454e52
#define CYCB	0x43594342
#define GFST	0x47465354
#define GIRS	0x47495253
#define CNTF	0x434e5446
#define GMRK	0x474d524b
#define LENF	0x4c454e46
#define NRLN	0x4e524c4e
#define FLDT	0x464c4454
#define FNAM	0x464e414d
#define FDEV	0x46444556
#define GISL	0x4749534c
#define SISL	0x5349534c
#define GIFL	0x4749464c
#define SIFL	0x5349464c
#define SAVE	0x53415645
#define ISAV	0x49534156
#define SAVI	0x53415649
#define BACK	0x4241434b
#define SSHR	0x53534852
#define SLNG	0x534c4e47
#define SCHR	0x53434852
#define GDBL	0x4744424c
#define GLNG	0x474c4e47
#define GSHR	0x47534852
#define GCHR	0x47434852
#define RMVE	0x524d5644
#define INSE	0x494e5345
#define GVST	0x47565354
#define SVST	0x53565354
#define FORW	0x464f5257
#define BCKW	0x42434b57

/* prototypes needed for macros */
Error cthg_(long,long,long *);
Error DDbid_(long b, long c);
Error DDint_(long b, long i, long c);
Error DDret_(long b, long *r, long c);
Error DDi_ret_(long b, long i, long *r, long c);
Error DDretstr_(long b, char *r, long c);
Error DDxifl_(long b, short l, short *c, short *f, short *p, char *v, long e);
Error DDxisl_(long b, short l, short *c, short *f, short *p, long e);
Error DDxsavx_(long b, char *n, char *d, short o, long e);
Error DDseti_(long b, short f, long l, long v, long e);
Error DDi2_ret_(long b, short f, long i, long *r, long c);
Error DDint3_(long b, short f, long l, long n, long c);

/* routines implemented as macro */
#define DDnextrec(b) DDbid_(b,NEXT)
#define DDprevrec(b) DDbid_(b,PREV)
#define DDfirstrec(b) DDbid_(b,FRST)
#define DDlastrec(b) DDbid_(b,LAST)
#define DDduplicate(b) DDbid_(b,DUPL)
#define DDclearmark(b) DDbid_(b,CMRK)
#define DDdelrec(b) DDbid_(b,DELE)
#define DDnewrec(b) DDbid_(b,NEWR)
#define DDimplement(b) DDbid_(b,IMPL)
#define DDindexupdate(b) DDbid_(b,IUPD)
#define DDindeximplement(b) DDbid_(b,IIMP)
#define DDindexremove(b) DDbid_(b,IRMV)
#define DDindexdelete(b) DDbid_(b,IDEL)
#define DDunusebuffer(b) DDbid_(b,UNUS)
#define DDsaverec(b) DDbid_(b,SAVR)
#define DDsavefinish(b) DDbid_(b,SAVF)
#define DDgarbage(b) DDbid_(b,GARB)
#define DDforward(b,i) DDint_(b,i,FORW)
#define DDbackward(b,i) DDint_(b,i,BCKW)
#define DDdefindex(b,i) DDint_(b,i,DEFI)
#define DDdeffield(b,i) DDint_(b,i,DEFF)
#define DDsetmark(b,i) DDint_(b,i,SMRK)
#define DDgetrec(b,i) DDint_(b,i,GREC)
#define DDset_irs(b,i) DDint_(b,i,SIRS)
#define DDfielddelete(b,i) DDint_(b,i,FLDD)
#define DDsetviewstatus(b,i) DDint_(b,(long)i,FLDD)
#define DDrecordid(b,r) DDret_(b,r,IDRE)
#define DDcountall(b,r) DDret_(b,r,CNTA)
#define DDcountrec(b,r) DDret_(b,r,CNTR)
#define DDindexid(b,r) DDret_(b,r,IDIN)
#define DDrecorddate(b,r) DDret_(b,r,DATE)
#define DDrecordlen(b,r) DDret_(b,r,LENR)
#define DDcyclebuffer(b,r) DDret_(b,r,CYCB)
#define DDfilestatus(b,r) DDret_(b,(long*)r,GFST)
#define DDget_irs(b,r) DDret_(b,(long*)r,GIRS)
#define DDnrfields(b,r) DDret_(b,(long*)r,CNTF)
#define DDgetmark(b,r) DDret_(b,(long*)r,GMRK)
#define DDviewstatus(b,r) DDret_(b,(long*)r,GMRK)
#define DDfieldlen(b,f,r) DDi_ret_(b,(long)f,r,LENF)
#define DDnrlines(b,f,r) DDi_ret_(b,(long)f,r,NRLN)
#define DDfieldtype(b,f,r) DDi_ret_(b,(long)f,(long *)r,FLDT)
#define DDfiledevice(b, r) DDretstr_(b,r,FDEV)
#define DDfilename(b, r) DDretstr_(b,r,FNAM)
#define DDdefbuffer(b) cthg_(DATAdesign,DEFB,&b)
#define DDgetsort(b,l,c,f,p) DDxisl_(b,l,c,f,p,GISL)
#define DDsetsort(b,l,c,f,p) DDxisl_(b,l,c,f,p,SISL)
#define DDgetfilter(b,l,c,f,p,v) DDxifl_(b,l,c,f,p,v,GIFL)
#define DDsetfilter(b,l,c,f,p,v) DDxifl_(b,l,c,f,p,v,SIFL)
#define DDsavefile(b,n,d,o) DDxsavx_(b,n,d,o,SAVE)
#define DDindexsave(b, n, d,o) DDxsavx_(b,n,d,o,ISAV)
#define DDsaveinit(b, n, d,o) DDxsavx_(b,n,d,o,SAVI)
#define DDbackfile(b, n, d,o) DDxsavx_(b,n,d,o,BACK)
#define DDsetlong(b,f,l,v) DDseti_(b,f,l,v,SLNG)
#define DDsetshort(b,f,l,v) DDseti_(b,f,l,(long)v,SSHR)
#define DDsetchar(b,f,l,v) DDseti_(b,f,l,(long)v,SCHR)
#define DDgetdouble(b,f,p,r) DDi2_ret_(b,f,p,(long*)r,GDBL)
#define DDgetlong(b,f,p,r) DDi2_ret_(b,f,p,r,GLNG)
#define DDgetshort(b,f,p,r) DDi2_ret_(b,f,p,(long*)r,GSHR)
#define DDget(b,f,p,r) DDi2_ret_(b,f,p,(long*)r,GCHR)
#define DDremoveel(b,f,l, n) DDint3_(b,f,l,n,RMVE)
#define DDinsertel(b,f,l,n) DDint3_(b,f,l,n,INSE)

/* routines which are not implemented as macro */
/* prototypes for access */
Error DDinit();
void  DDfree();
Error DDnewfile(char *c);
Error DDaddfield(long b, char *c, short t);
Error DDfieldid(long b, char *c, short *r);
Error DDfieldname(long b, short f, char *r);
Error DDcyclefile(long *i, char *r);
Error DDcyclefield(long b, short *i, short *t, char *r);
Error DDfieldclear(long b, short f, short s);
Error DDfieldrename(long b, short f, char *n);
Error DDgetfield(long b, short f, long l, char *p, long *r);
Error DDsetfield(long b, short f, long l, char *p);
Error DDbufferid(long *r);
Error DDindexload(long b, char *n, char *d);
Error DDusefile(long b, char *n, char *d, short a);
Error DDsetfilestatus(long b, short s, char *n, char *d);
Error DDsetdouble(long b, short f, long l, double v);
Error DDsetline(long b, short f, long l, char *v);
Error DDgetline(long b, short f, long i, char *r, short space);
Error DDlinelen(long b, short f, long l, long *r);
Error DDfindstring(long b, short f, short cmp, char *v, short *rf, short *pl);
Error DDfinddouble(long b, short f, short cmp, double v, short *rf, short *pl);
Error DDfindinteger(long b, short f, short cmp, long v, short *rf, short *pl);
Error DDindexfind(long b, char *v, long *r);
Error DDsortfile(long b, int nr, ...);
Error DDfilter(long b, int nr, ...);
