#ifndef _SYSLIB_ERR_H
#define _SYSLIB_ERR_H

/*
	Standard header file for PROGS SMS C library

	definition of error codes

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 6 October 1994
*/
typedef int Error;

#define ERR_OK			  0 	/* NO error occured */
#define ERR_NC			 -1 	/* operation Not Complete */
#define ERR_IJOB		 -2 	/* Invalid JOB id */
#define ERR_IMEM		 -3 	/* Insufficient MEMory */
#define ERR_ORNG		 -4 	/* parameter Outside permitted RaNGe */
#define ERR_BFFL		 -5 	/* BuFfer FuLl */
#define ERR_ICHN		 -6 	/* Invalid CHaNnel id */
#define ERR_FDNF		 -7 	/* File or Device Not Found */
#define ERR_ITNF		 -7 	/* ITem Not Found */
#define ERR_FEX 		 -8 	/* File already EXists */
#define ERR_FDIU		 -9 	/* File or Device In Use */
#define ERR_EOF 		-10 	/* End Of File */
#define ERR_DRFL		-11 	/* DRive FuLl */
#define ERR_INAM		-12 	/* Invalid file, device or thing NAMe */
#define ERR_TRNS		-13 	/* TRaNSmission error */
#define ERR_FMTF		-14 	/* ForMaT drive Failed */
#define ERR_IPAR		-15 	/* Invalid PARameter */
#define ERR_MCHK		-16 	/* file system Medium CHecK failed */
#define ERR_IEXP		-17 	/* Invalid EXPression */
#define ERR_OVFL		-18 	/* arithmetic OVerFLow */
#define ERR_NIMP		-19 	/* operation Not IMPlemented */
#define ERR_RDO 		-20 	/* ReaD Only permitted */
#define ERR_ISYN		-21 	/* Invalid SYNtax */
#define ERR_RWF 		-22 	/* Read or Write Failed */
#define ERR_NOMS		-22 	/* NO error MeSsage */
#define ERR_ACCD		-23 	/* ACCess Denied */

#define ERR_MAXLEN		42		/* max length of error message (one too long) */

Error ERRMessageGet(Error err, char *message);

#define ERROR_BUILD(name,string) \
	struct {short len; char mess[sizeof(string)+1];} name = { sizeof(string), string }
#define ERROR_EXTERN(name) \
	extern struct {short len; char mess[2];} name
#define ERROR_CODE(name) ((Error)&name^0x80000000)

#endif _SYSLIB_ERR_H
