#ifndef _SYSLIB_KBD_H
#define _SYSLIB_KBD_H

/*
	Standard header file for PROGS SMS C library

	keyboard handling library

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 12 May 1996
*/

#include <err.h>

/* list of rows and keys on each row :										*/
/* each line is a row, each bit indicates a key 							*/
/* for row 8 onwards numbers and mathematical chars are on the number pad	*/
/*			0		1		2		3		4		5		6		7		*/
/*																			*/
/*	0		F4		F1		5		F2		F3		F5		4		7		*/
/*	1		ENTER	LEFT	UP		ESC 	RIGHT	\		SPACE	DOWN	*/
/*	2		]		Z		.		C		B		`		M		'       */
/*	3		[		CAPS	K		S		F		-		G		;		*/
/*	4		L		3		H		1		A		P		D		J		*/
/*	5		9		W		I		TAB 	R		-		Y		O		*/
/*	6		8		2		6		Q		E		0		T		U		*/
/*	7		SHIFT	CTRL	ALT 	X		V		/		N		,		*/
/*	8		~		BKSP			F6		F7		F8		F9		10		*/
/*	9						CLR/HOME		-				+				*/
/*	10				INSERT	DELETE											*/
/*	11																		*/
/*	12		UNDO	HELP	(		)		/		*		7		8		*/
/*	13		9		4		5		6		1		2		3		0		*/
/*	14		.		ENTER													*/

Error KBDDirect(char row, char *result);
int KBDPressedAlt();
int KBDPressedCtrl();
int KBDPressedShift();

#endif _SYSLIB_KBD_H
