#ifndef _SYSLIB_LIMITS_H
#define _SYSLIB_LIMITS_H
/*
	Standard header file for PROGS SMS C library

	limits of the buil in types

	(c) PROGS, Professional & Graphical Software
*/



#define CHAR_BIT	8			/* bits per char					*/
#define SCHAR_MAX	127 		/* max value for signed char		*/
#define SCHAR_MIN (-SCHAR_MAX-1)/* min value for signed char		*/
#define UCHAR_MAX	255 		/* max value for unsigned char		*/
#define CHAR_MAX	UCHAR_MAX	/* max value for char				*/
#define CHAR_MIN	0			/* min value for char				*/
#define MB_LEN_MAX	1			/* bytes in multi-byte characters	*/
#define SHRT_MAX	32767		/* max value for short int			*/
#define SHRT_MIN  (-SHRT_MAX-1) /* min value for short int			*/
#define USHRT_MAX	65535		/* max value for unsigned short int */
#define INT_MAX 	2147483647	/* max value for int				*/
#define INT_MIN   (-INT_MAX-1)	/* min value for int				*/
#define UINT_MAX	4294967295	/* max value for unsigned int		*/
#define LONG_MAX	2147483647	/* max value for long int			*/
#define LONG_MIN  (-LONG_MAX-1) /* min value for long int			*/
								/*	NOTE that it is very important	*/
								/* that LONG_MIN is defined as above*/
								/* and not as -2147483648 because	*/
								/* under ANSI the constant part is	*/
								/* evaluated before the minus is	*/
								/* applied.  A constant of this size*/
								/* is unsigned which has all sorts	*/
								/* of unfortunate consequences. When*/
								/* written as above it is instead a */
								/* expression which gives the result*/
								/* that would be expected.			*/
#define ULONG_MAX	4294967295	/* max value for unsigned long int	*/

#define DBL_DIG 		15
#define DBL_EPSILON 	2.2204460492503131e-16
#define DBL_MANT_DIG	53
#define DBL_MAX 		1.7976931348623157e+308
#define DBL_MAX_10_EXP	308
#define DBL_MAX_EXP 	1024
#define DBL_MIN 		2.2250738585072014e-308
#define DBL_MIN_10_EXP	-307
#define DBL_MIN_EXP 	-1021

#endif _SYSLIB_LIMITS_H
